import es, gamethread, playerlib
from random import choice as rChoice
from random import randint as rInt

###---DEFAULT SETTINGS---###
# switch on(1)/off(0) by default
first_zombies_enabled = 1

# percent of zombies by default
first_zombies_percent = 30

# teleport all first zombies by default (0 = off, 1 = on)
first_zombies_teleport = 1
###----------------------###

added_zombies = []
def load():
	es.ServerVar('fz_tele', first_zombies_teleport)
	es.ServerVar('fz_enable', first_zombies_enabled)
	es.ServerVar('fz_percent', first_zombies_percent)

def unload():
	gamethread.cancelDelayed('keep_first_zombify')
	gamethread.cancelDelayed('cancel_keep_first_zombify')
	
def random():
	min_time = es.getInt('zombie_timer_min')
	max_time = es.getInt('zombie_timer_max')
	es.msg('[ZTEST]: fz_tele: %s'%(es.getInt('fz_tele')))
		
def round_freeze_end(ev):
	if es.getInt('fz_enable') == 1:
		gamethread.delayedname(es.getInt('zombie_timer_min'), 'keep_first_zombify',keep_first_zombify, args=())
		gamethread.delayedname(es.getInt('zombie_timer_max'), 'cancel_keep_first_zombify',gamethread.delayedname, ('keep_first_zombify'))

def round_end(ev):
	gamethread.cancelDelayed('keep_first_zombify')
	gamethread.cancelDelayed('cancel_keep_first_zombify')

def add_zombies(count):
	i = 0
	while i < count:
		playerlist = playerlib.getPlayerList('#ct,#alive')
		if len(playerlist) <= 1:
			break
		player = rChoice(playerlist)
		if not player.userid in added_zombies:
			if es.getInt('fz_tele') == 1:
				es.server.queuecmd('es_setplayerprop %s "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_iTeamNum" %s' %(player.userid, rInt(2,3)))
				es.server.queuecmd('est_Spawn %s 1' %(player.userid))
			es.server.queuecmd('zombie_player #%s' %(player.userid))
			added_zombies.append(player.userid)
			i = i + 1
	del added_zombies[:]
		
def keep_first_zombify():
	gamethread.delayedname(0.1, 'keep_first_zombify',keep_first_zombify, args=())	
	if not es.getInt('zombie_first_zombie') == 0:
		first_zombie(es.getInt('zombie_first_zombie'))
		gamethread.cancelDelayed('keep_first_zombify')
		gamethread.cancelDelayed('cancel_keep_first_zombify')
		
def first_zombie(userid):
	if es.getInt('fz_tele') == 1:
		es.server.queuecmd('es_setplayerprop %s "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_iTeamNum" %s' %(userid, rInt(2,3)))
		es.server.queuecmd('est_Spawn %s 1' %(userid))
		es.server.queuecmd('zombie_player #%s' %(userid))
	playerlist = playerlib.getPlayerList('#alive')
	first_zombies_count = int(((float(first_zombies_percent)/100.0)*len(playerlist)) - 1)
	add_zombies(first_zombies_count)